#include <LiquidCrystal.h>

// déclaration de l'écran LCD connecté à l'Arduino
LiquidCrystal lcd(8,9,4,5,6,7);

// nombre de messages envoyés et reçus
long msg_envoi = 0;
long msg_recu = 0;

// nombre de ms à l'instant du dernier envoi et de la dernière réception (pour mesurer l'écart)
long last_sent = 0;
long last_seen = 0;

// caractère envoyé (s = sent) et reçu (r = receive)
int s = 0;
int r = 0;

// temps écoulé pour la dernière coupure
long last_err = 0;

// temps maximum écoulé pour une coupure
long max_err = 0;

// temps moyen d'une coupure
long moyenne = 0;

// nombre de coupures connues depuis le début
long count = 0;

boolean coupure = false;

void setup()
{
  // deux liaisons séries : celle de l'USB et celle du XBee
  Serial.begin(9600);
  Serial1.begin(9600); 

  // initialisation de l'écran I2C
  lcd.begin(16, 2);             
  lcd.setCursor(0,0);
  lcd.print("Test XBee"); 

  delay(1000);

  lcd.clear();

}


void loop()
{

  Serial1.write(s);
  delay(10);

  lcd.setCursor(15,0);
  lcd.write(s);

  s++;
  msg_envoi++;
  last_sent = millis();

  while (Serial1.available() > 0) {

    // nouvelle réception    

    r = Serial1.read();

    last_seen = millis();

    lcd.setCursor(15,1);
    lcd.write(r);
    msg_recu++;

  }

  // vérifier si on est en connexion ou en coupure 
  if (last_sent-last_seen > 0) 
  {  
    if (!coupure) {
      count++;
      coupure = true; 
    }
    last_err = last_sent-last_seen; 
    max_err = max(last_err,max_err);
  } 
  else {

    if (coupure) {
      // fin de la coupure
      coupure = false; 

      moyenne = (moyenne*(count-1)+last_err)/count;

      Serial.println(moyenne);
    }

  }




  // affichage des secondes

  lcd.setCursor(0,1);
  lcd.print(millis()/1000); 
  lcd.print("s ");

  lcd.print(count);
  lcd.print(" erreurs");

  // affichage des stats

  lcd.setCursor(0,0);
  lcd.print(100*msg_recu/msg_envoi);
  lcd.print("% ");


  // alterner les affichages

  switch ((millis()/1000)%3) {
  case 0:
    lcd.print(max_err);
    lcd.print("ms max");
    break;
  case 1:
    lcd.print(moyenne);
    lcd.print("ms moy");
    break;
  case 2:
    lcd.print(last_err);
    lcd.print("ms der");
    break;

  }

  if (coupure) {
    lcd.print("!");
  } 
  else {
    lcd.print(" ");
  }



}



















